/* Copyright (C) 2003 Albert Seward
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Correction done in the code by Jrgen stensen (oldman) feb 2005 because playlist did not function for linux.
 *  The playlist should know work on Linux and windows with pls amd m3u files.
 *  This correction is part of a correction that is done also for the Mount class.
 *  Some part of the code I did not understand the purpose of. It has been removed.
 */

package sf.jlink;
import java.io.*;
import java.util.*;

abstract public class PlayList {
     
    static public Vector list(String path, boolean fullPath) {     
        Vector ret = new Vector();
        BufferedReader pls;
        String line;
        try {
            File file = new File(path);
            if(!file.isFile() || !file.canRead())
                return null;
            pls = new BufferedReader(new FileReader(file));
            line = pls.readLine();
        
            while((line = pls.readLine()) != null) {
            if(line.startsWith("#")) continue;
                if(fullPath==false){
		    if(path.toLowerCase().indexOf(".pls")>-1||path.toLowerCase().indexOf("m3u")>-1){
		    if(line.indexOf("/")>-1){
		    line=line.substring(line.lastIndexOf("/")+1);
		    }else
		    if(line.indexOf("\\")>-1){
		    line=line.substring(line.lastIndexOf("\\")+1);
		    }else
		    if(path.toLowerCase().indexOf(".pls")>-1){
		    line = line.substring(line.indexOf("=") + 1);
		    }else
		    if(path.toLowerCase().indexOf(".m3u")>-1){
		    // nothing to do
		    }
		    }
		    }else
		    {
		    if(path.toLowerCase().indexOf(".pls")>-1){
                    line = line.substring(line.indexOf("=") + 1);
		    }else
		    if(path.toLowerCase().indexOf(".m3u")>-1){
		    // nothing to do line is OK
		    }
		    }
	    if(line.indexOf("NumberOfEntries=")>-1){
		    }else
                ret.add(line);
            }
        } catch(Exception e) {
            return null;
        } 
        return(ret);
      
    }
     
    static public File getFile(String path) {
        try {
	String subpath=null;
	String file=null;
        if(path.toLowerCase().indexOf(".m3u")>-1){
	      subpath = path.substring(0,path.toLowerCase().lastIndexOf(".m3u")+4);
	      file = path.substring(path.toLowerCase().lastIndexOf(".m3u")+5);
	      }else
	      if(path.toLowerCase().indexOf(".pls")>-1){
	      subpath = path.substring(0,path.toLowerCase().lastIndexOf(".pls")+4);
	      file = path.substring(path.toLowerCase().lastIndexOf(".pls")+5);
	      }
              if(subpath.toLowerCase().endsWith(".pls") || subpath.toLowerCase().endsWith(".m3u")) {
  //            String file = "\\" + path.substring(subpath.length()+1);
                for(Iterator i = list(subpath, true).iterator(); i.hasNext();) {
                    String name = (String)i.next();
		    String xname=null;
		    if(File.separatorChar=='/'){
		    name=name.replace('\\','/');
		    file=file.replace('\\','/');
		    }else
		    {
		    name=name.replace('/','\\');
                    file=file.replace('/','\\');
		    }
		    
		    JLink.debug("Name:"+name);
		    JLink.debug("File:"+file);
	             if(name.endsWith(file)) {
                        File f = new File(name);
                        if(f.isFile() && f.canRead()){
	                return(f);
			}
              		boolean start=false;
			boolean start2=false;
			if(name.substring(0,1).equals("/"))start=true;
			if(name.substring(0,1).equals("\\"))start=true;
			if(name.substring(1,3).equals(":\\"))start2=true;
			JLink.debug("Start="+name);
			JLink.debug("Subpath="+subpath);
			if(subpath.lastIndexOf("/")>-1){
		        File f1 = new File(subpath.substring(0,subpath.lastIndexOf("/"))+File.separatorChar+name);
			if(f1.isFile() && f1.canRead()){
                        return(f1);
			}
		
			boolean many=true;
			String n1=null;
			if(name.indexOf(File.separatorChar)>-1){
			many=true;
			n1=name.substring(name.indexOf(File.separatorChar)+1);
			}
			else
			many=false;
			while(many)
			{
			File f3 = new File(subpath.substring(0,subpath.lastIndexOf("/"))+File.separatorChar+n1);
			if(f3.isFile() && f3.canRead()){
                        return(f3);
			}
			if(n1.indexOf(File.separatorChar)>-1){
			n1=n1.substring(n1.indexOf(File.separatorChar)+1);
		        }
			else
			many=false;
			}
			
			}
			}
			}
			}
	           
        } catch(Exception e) {}
        return null;
	}
	}

